# Copyright 2021 The Kubeflow Authors
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

import kfp
from .output_a_directory import dir_pipeline, dir_pipeline_v2
from ...test.util import run_pipeline_func, TestCase

run_pipeline_func([
    TestCase(
        pipeline_func=dir_pipeline_v2,
        mode=kfp.dsl.PipelineExecutionMode.V2_COMPATIBLE,
    ),
    TestCase(
        pipeline_func=dir_pipeline,
        mode=kfp.dsl.PipelineExecutionMode.V2_COMPATIBLE,
    ),
    TestCase(
        pipeline_func=dir_pipeline_v2,
        mode=kfp.dsl.PipelineExecutionMode.V2_ENGINE,
    ),
    TestCase(
        pipeline_func=dir_pipeline,
        mode=kfp.dsl.PipelineExecutionMode.V2_ENGINE,
    ),
    TestCase(
        pipeline_func=dir_pipeline,
        mode=kfp.dsl.PipelineExecutionMode.V1_LEGACY,
    ),
])
